import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Project createProject(String name) {
    Project proj = new Project();
    proj.setName(name);
    em.persist(proj);

    return proj;
  }

  public Collection<Project> findAllProjects() {
    Query query = em.createQuery("SELECT p FROM Project p");
    return (Collection<Project>) query.getResultList();
  }

  public Professor createProfessor(String name, long salary) {
    Professor emp = new Professor();
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }

  public Professor addProfessorProject(int empId, int projId) {
    Professor emp = em.find(Professor.class, empId);
    Project proj = em.find(Project.class, projId);
    proj.addProfessor(emp);
    return emp;
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }
}
